Index: org/postgresql/errors.properties
===================================================================
RCS file: /projects/cvsroot/pgsql-server/src/interfaces/jdbc/org/postgresql/errors.properties,v
retrieving revision 1.22
diff -c -p -r1.22 errors.properties
*** org/postgresql/errors.properties	9 Jul 2003 05:12:03 -0000	1.22
--- org/postgresql/errors.properties	22 Jul 2003 19:17:30 -0000
*************** postgresql.input.rows.gt0:Maximum number
*** 103,105 ****
--- 103,106 ----
  postgresql.format.baddate:The date given: {0} does not match the format required: {1}.
  postgresql.format.badtime:The time given: {0} does not match the format required: {1}.
  postgresql.format.badtimestamp:The timestamp given {0} does not match the format required: {1}.
+ postgresql.need.v3:The V3 protocol is needed to perform this operation.
Index: org/postgresql/core/QueryExecutor.java
===================================================================
RCS file: /projects/cvsroot/pgsql-server/src/interfaces/jdbc/org/postgresql/core/QueryExecutor.java,v
retrieving revision 1.22
diff -c -p -r1.22 QueryExecutor.java
*** org/postgresql/core/QueryExecutor.java	29 May 2003 03:21:32 -0000	1.22
--- org/postgresql/core/QueryExecutor.java	22 Jul 2003 19:17:31 -0000
*************** public class QueryExecutor
*** 65,70 ****
--- 65,80 ----
  
  		qe.execute();
  	}
+ 	
+ 	public static BaseResultSet describe (BaseStatement stmt, String prepStatement) throws SQLException
+ 	{
+ 		QueryExecutor qe = new QueryExecutor();
+ 		qe.statement = stmt;
+ 		qe.connection = stmt.getPGConnection();
+ 		qe.pgStream = qe.connection.getPGStream();
+ 		return qe.describeStatement(prepStatement);
+ 	}
+ 	
  
  
  	private QueryExecutor ()
*************** public class QueryExecutor
*** 299,304 ****
--- 309,455 ----
  			return rs;
  		}
  	}
+ 
+ 	private BaseResultSet describeStatement(String preparedStatement) throws SQLException
+ 	{
+ 		try
+ 		{
+ 			QueryExecutor qe = new QueryExecutor();
+ 			Encoding l_encoding = connection.getEncoding();
+ 			byte[][] empty = new byte[1][];
+ 			byte[][] byteStmt = new byte[1][];
+ 			int l_msgSize = 0;
+ 			StringBuffer errorMessage = null;
+ 						
+ 			//first, need to create the prepared statement in the backend.		
+ 			empty[0] = l_encoding.encode("");
+ 									
+ 			//change the ? into $1, $2, ...
+ 			StringBuffer sbuf = new StringBuffer(preparedStatement);
+ 			int j = 1;
+ 			for (int i = 0; i < sbuf.length(); i++)
+ 			{
+ 				if (sbuf.charAt(i)=='?')
+ 				{
+ 					sbuf.deleteCharAt(i);
+ 					sbuf.insert(i,'$');
+ 					sbuf.insert(i+1, j);
+ 					j++;
+ 				}
+ 			}
+ 			byteStmt[0] = l_encoding.encode(sbuf.toString());
+ 
+ 			//time to send.
+ 			pgStream.Send(l_encoding.encode("P"));	
+ 			l_msgSize = 4 + empty[0].length + byteStmt[0].length + 2 + 2;
+ 			pgStream.SendInteger(l_msgSize,4);
+ 			pgStream.Send(empty[0]);
+ 			pgStream.SendChar(0);
+ 			pgStream.Send(byteStmt[0]);
+ 			pgStream.SendInteger(0,2);
+ 			pgStream.SendChar(0);
+ 			pgStream.flush();
+ 			
+ 			//flush the backend output back to us
+ 			pgStream.Send(l_encoding.encode("H"));
+ 			pgStream.SendInteger(4,4);
+ 			pgStream.flush();
+ 			
+ 			char a;
+ 			boolean l_endQuery = false;
+ 			while (!l_endQuery)
+ 			{		
+ 				a = (char)pgStream.ReceiveChar();
+ 				switch(a)			
+ 				{
+ 					//ParseComplete
+ 					case '1':
+ 						int tmpb = pgStream.ReceiveIntegerR(4);
+ 						//pick up all the trash.
+ 						pgStream.Receive(tmpb-4);
+ 						l_endQuery = true;
+ 						break;
+ 					//ErrorResponse
+ 					case 'E':
+ 						if ( errorMessage == null )
+ 							errorMessage = new StringBuffer();
+ 						int l_elen = pgStream.ReceiveIntegerR(4);
+ 						errorMessage.append(connection.getEncoding().decode(pgStream.Receive(l_elen-4)));
+ 						break;
+ 				}
+ 			}
+ 
+ 			if ( errorMessage != null )
+ 				throw new SQLException( errorMessage.toString() );
+ 
+ 			//-- Begin describe
+ 			pgStream.Send(l_encoding.encode("D"));
+ 			l_msgSize = 4 + empty[0].length + 1 + 1;
+ 			pgStream.SendInteger(l_msgSize,4);
+ 			pgStream.Send(l_encoding.encode("S"));
+ 			pgStream.Send(empty[0]);
+ 			pgStream.SendChar(0);
+ 			pgStream.flush(); 
+ 
+ 			//flush the backend output back to us
+ 			pgStream.Send(l_encoding.encode("H"));
+ 			pgStream.SendInteger(4,4);
+ 			pgStream.flush();			
+ 																		
+ 			l_endQuery = false;
+ 			while (!l_endQuery)
+ 			{
+ 				a = (char)pgStream.ReceiveChar();
+ 				switch(a)
+ 				{
+ 					//ParameterDescription
+ 					case 't':
+ 						//don't really care about length, as the next one will tell us.
+ 						pgStream.ReceiveIntegerR(4);
+ 						int tmp = pgStream.ReceiveIntegerR(2);
+ 						//TODO: maybe use this for something?
+ 						pgStream.Receive(tmp*4);		
+ 						break;
+ 					//RowDescription
+ 					case 'T':
+ 						receiveFieldsV3();
+ 						l_endQuery = true;
+ 						break;
+ 					//ErrorResponse
+ 					case 'E':
+ 						if ( errorMessage == null )
+ 							errorMessage = new StringBuffer();
+ 						int l_elen = pgStream.ReceiveIntegerR(4);
+ 						errorMessage.append(connection.getEncoding().decode(pgStream.Receive(l_elen-4)));
+ 						break;
+ 					//NoData
+ 					case 'n':
+ 						//we must make empty fields.
+ 						if (fields != null)
+ 							throw new PSQLException("postgresql.con.multres");
+ 						fields = new Field[0];
+ 						break;
+ 					//Termination
+ 					case 'Z':
+ 						if (pgStream.ReceiveIntegerR(4) != 5) 
+ 							throw new PSQLException("postgresql.con.setup"); 
+ 						char l_tStatus = (char)pgStream.ReceiveChar();
+ 						l_endQuery = true;
+ 						break;
+ 				}
+ 			}
+ 			//If we got an error, throw it back out.
+ 			if ( errorMessage != null )
+ 				throw new SQLException( errorMessage.toString() );
+ 			
+ 			return statement.createResultSet(fields, tuples, status, update_count, insert_oid, binaryCursor);
+ 			
+ 		}
+ 		catch (IOException e)
+ 		{
+ 			throw new PSQLException("postgresql.con.ioerror");
+ 		}
+ 	}	
  
  	/*
  	 * Send a query to the backend.
Index: org/postgresql/jdbc1/AbstractJdbc1Statement.java
===================================================================
RCS file: /projects/cvsroot/pgsql-server/src/interfaces/jdbc/org/postgresql/jdbc1/AbstractJdbc1Statement.java,v
retrieving revision 1.28
diff -c -p -r1.28 AbstractJdbc1Statement.java
*** org/postgresql/jdbc1/AbstractJdbc1Statement.java	22 Jul 2003 05:17:09 -0000	1.28
--- org/postgresql/jdbc1/AbstractJdbc1Statement.java	22 Jul 2003 19:17:34 -0000
*************** public abstract class AbstractJdbc1State
*** 79,84 ****
--- 79,85 ----
  	private static final String RESULT_ALIAS = "result";
  	private String originalSql = "";
  	private boolean isFunction;
+ 	protected String original;
  	// functionReturnType contains the user supplied value to check
  	// testReturn contains a modified version to make it easier to
  	// check the getXXX methods..
*************** public abstract class AbstractJdbc1State
*** 99,104 ****
--- 100,106 ----
  	public AbstractJdbc1Statement (BaseConnection connection, String p_sql) throws SQLException
  	{
  		this.connection = connection;
+ 		original = p_sql;
  		parseSqlStmt(p_sql);  // this allows Callable stmt to override
  	}
  
Index: org/postgresql/jdbc2/AbstractJdbc2Statement.java
===================================================================
RCS file: /projects/cvsroot/pgsql-server/src/interfaces/jdbc/org/postgresql/jdbc2/AbstractJdbc2Statement.java,v
retrieving revision 1.15
diff -c -p -r1.15 AbstractJdbc2Statement.java
*** org/postgresql/jdbc2/AbstractJdbc2Statement.java	30 Jun 2003 16:38:30 -0000	1.15
--- org/postgresql/jdbc2/AbstractJdbc2Statement.java	22 Jul 2003 19:17:35 -0000
*************** public abstract class AbstractJdbc2State
*** 186,191 ****
--- 186,200 ----
  
  	public ResultSetMetaData getMetaData() throws SQLException
  	{
+ 		//requirement to try to use server side prepare/describe statements.
+ 		if (this instanceof PreparedStatement)
+ 		{
+ 			if (connection.getPGProtocolVersionMajor() == 3)
+ 				return org.postgresql.core.QueryExecutor.describe(this, original).getMetaData();
+ 			else
+ 				throw new PSQLException("postgresql.need.v3");
+ 			
+ 		}
  		ResultSet rs = getResultSet();
  		if (rs != null)
  			return rs.getMetaData();
